SELECT
  AN.NUMERO
  , ((SELECT COUNT(*) FROM LACTACAO RE WHERE RE.CDANIMAL = LAC.CDANIMAL AND RE.DTINICIO <= LAC.DTINICIO) + COALESCE(AN.NUMPARTOENTRADA, 0)) AS ORDEM_LACTACAO
  , LAC.DTINICIO AS INICIO
  , LAC.DTFIM AS SECAGEM
  , (LAC.DTFIM - LAC.DTINICIO) AS DURACAO
  , P1.PRODUCAO305 AS PRODUCAO_305
  , P2.PRODUCAO305 AS PRODUCAO_305_ANT1
  , P3.PRODUCAO305 AS PRODUCAO_305_ANT2
  , P4.PRODUCAO305 AS PRODUCAO_305_ANT3
  , (CASE WHEN (((CASE WHEN (P1.PRODUCAO305 > 0) THEN 1 ELSE 0 END) +
                   (CASE WHEN (P2.PRODUCAO305 > 0) THEN 1 ELSE 0 END) +
                   (CASE WHEN (P3.PRODUCAO305 > 0) THEN 1 ELSE 0 END) +
                   (CASE WHEN (P4.PRODUCAO305 > 0) THEN 1 ELSE 0 END)) > 0)
       THEN ((P1.PRODUCAO305+P2.PRODUCAO305+P3.PRODUCAO305+P4.PRODUCAO305)/
               ((CASE WHEN (P1.PRODUCAO305 > 0) THEN 1 ELSE 0 END) +
               (CASE WHEN (P2.PRODUCAO305 > 0) THEN 1 ELSE 0 END) +
               (CASE WHEN (P3.PRODUCAO305 > 0) THEN 1 ELSE 0 END) +
               (CASE WHEN (P4.PRODUCAO305 > 0) THEN 1 ELSE 0 END)))
        ELSE 0 END) AS MEDIA_PRODUCAO_305_ULT_4
FROM
  ANIMAL AN
  LEFT JOIN LACTACAO LAC ON LAC.CDANIMAL = AN.CDANIMAL
  LEFT JOIN SP_PRODUCAO305(LAC.CDLACTACAO) P1 ON 1 = 1
  LEFT JOIN LACTACAO LAC2 ON LAC2.CDLACTACAO =
    (SELECT FIRST 1 RE.CDLACTACAO FROM LACTACAO RE WHERE RE.CDANIMAL = LAC.CDANIMAL AND RE.DTINICIO < LAC.DTINICIO ORDER BY RE.DTINICIO DESC)
  LEFT JOIN SP_PRODUCAO305(LAC2.CDLACTACAO) P2 ON 1 = 1
  LEFT JOIN LACTACAO LAC3 ON LAC3.CDLACTACAO =
    (SELECT FIRST 1 RE.CDLACTACAO FROM LACTACAO RE WHERE RE.CDANIMAL = LAC2.CDANIMAL AND RE.DTINICIO < LAC2.DTINICIO ORDER BY RE.DTINICIO DESC)
  LEFT JOIN SP_PRODUCAO305(LAC3.CDLACTACAO) P3 ON 1 = 1
  LEFT JOIN LACTACAO LAC4 ON LAC4.CDLACTACAO =
    (SELECT FIRST 1 RE.CDLACTACAO FROM LACTACAO RE WHERE RE.CDANIMAL = LAC3.CDANIMAL AND RE.DTINICIO < LAC3.DTINICIO ORDER BY RE.DTINICIO DESC)
  LEFT JOIN SP_PRODUCAO305(LAC4.CDLACTACAO) P4 ON 1 = 1
WHERE
  AN.CDSETOR = 1
  AND LAC.DTFIM BETWEEN '2016-01-01' AND '2017-03-31'
  AND ((LAC.DTFIM - LAC.DTINICIO) >= 305)
  AND (((SELECT COUNT(*) FROM LACTACAO RE WHERE RE.CDANIMAL = LAC.CDANIMAL AND RE.DTINICIO <= LAC.DTINICIO) + COALESCE(AN.NUMPARTOENTRADA, 0)) <= 4)



